#include "StopAndWaitTraverser.h"
#include "SceneEntity.h"


namespace CHCDemo
{

using namespace std;



StopAndWaitTraverser::StopAndWaitTraverser(): RenderTraverser() 
{
}


StopAndWaitTraverser::~StopAndWaitTraverser()
{
	//DelQueries();
}


void StopAndWaitTraverser::Render()
{
	mStats.Reset();
	mRenderState->mTexturesEnabled = false;
	EnqueueNode(mBvh->GetRoot());

	//cout<<"\n***** starting frame **********\n";
	int traversed = 0;
	while (!mDistanceQueue.empty())
	{
		BvhNode *node = mDistanceQueue.top();
		mDistanceQueue.pop();
	
		//float d = mBvh->GetDistance(node);cout << d << " ";

		// interesting for the visualization, so rest and set
		node->SetVisible(false);


		if (mBvh->IsWithinViewFrustum(node))
		{
			// if intersects near plane assume visible and don't issue test
			if (IntersectsNearPlane(node))
			{
				TraverseNode(node);
			}
			else
			{
				OcclusionQuery *query = IssueOcclusionQuery(node, false);

				int visiblePixels = query->GetQueryResult();

				if (visiblePixels > mVisibilityThreshold)
				{
					//cout<< "visible: " << visiblePixels << endl;
					// update node's visited flag => needed for rendering
					// so set it also here
					//node->SetLastVisited(mFrameID);
					//node->SetVisible(true);
				
					TraverseNode(node);
				}
				else
				{
					++ mStats.mNumQueryCulledNodes;
				}
			}
		}
		else
		{
			++ mStats.mNumFrustumCulledNodes;
		}
		//cout << "intersect: " << intersect << " bx " << node->GetBox() << endl;
	}

	mQueryHandler.ResetQueries();
	//std::cout << "traversed: " << traversed << std::endl;
}

}